package com.lukmanh.belajar.reactive;

import org.springframework.boot.ApplicationRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.Bean;
import org.springframework.data.r2dbc.core.DatabaseClient;
import reactor.blockhound.BlockHound;

@SpringBootApplication
public class App {
    public static void main(String[] args) {
        BlockHound.install();
        SpringApplication.run(App.class, args);
    }

    @Bean
    ApplicationRunner createDb(DatabaseClient client) {
        return args -> {
            client.execute("DROP TABLE IF EXISTS contact").then().block();
            client.execute("create table if not exists contact(" +
                    "id bigint generated by default as identity constraint contact_pkey primary key," +
                    "name varchar(255) not null," +
                    "phone varchar(255) not null" +
                    ")").then().block();
        };
    }
}